package com.ruoyi.cai.mq;

import org.springframework.amqp.core.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;


@Configuration
public class CheckTimeOutMqConfig {

    public static final String EXCHANGE_NAME = "checkRoomTimeExchange";
    public static final String QUEUE_NAME = "checkRoomTimeQueue";
    public static final String ROUTING_KEY = "checkRoomTimeRouting";

    @Bean
    public CustomExchange delayedExchange() {
        HashMap<String,Object> args = new HashMap<>();
        args.put("x-delayed-type", "direct");
        return new CustomExchange(EXCHANGE_NAME,
                "x-delayed-message", // 消息类型
                true, // 是否持久化
                false,// 是否自动删除
                args);
    }

    @Bean
    public Queue delayedQueue() {
        return QueueBuilder.durable(QUEUE_NAME)
                .withArgument("x-delayed-type", "direct")
                .build();
    }

    @Bean
    public Binding delayedBinding(Queue delayedQueue,CustomExchange delayedExchange) {
        return BindingBuilder.bind(delayedQueue()).to(delayedExchange()).with(ROUTING_KEY).noargs();
    }

}
